package be.iminds.ilabt.jfed.restapi.dao;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Frequency;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Result;
import be.iminds.ilabt.jfed.restapi.json.Experiment;
import org.skife.jdbi.v2.sqlobject.Bind;
import org.skife.jdbi.v2.sqlobject.BindBean;
import org.skife.jdbi.v2.sqlobject.SqlQuery;
import org.skife.jdbi.v2.sqlobject.SqlUpdate;
import org.skife.jdbi.v2.sqlobject.customizers.RegisterMapper;

import javax.validation.constraints.NotNull;
import java.sql.Timestamp;
import java.util.List;

@RegisterMapper(ExperimentMapper.class)
public interface ExperimentDao {
//    @SqlQuery("SELECT \"id\",\"name\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
    @SqlQuery("SELECT \"id\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
            "\"speaks_for_credential\",\"speaking_for\",\"project\",\"slice_name\",\"slice_urn\",\"am_url\"," +
            "array_to_string(\"shared_with\", ' ') AS shared_with_ssv,\"owner\",\"status\",\"status_details\" " +
            " FROM experiment " +
            " WHERE id=:id")
    Experiment findById(@NotNull @Bind("id") Long id);

    //array_to_string(rc.configset_id, ',') AS configset_id_csv


//    @SqlQuery("SELECT \"id\",\"name\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
    @SqlQuery("SELECT \"id\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
                "\"speaks_for_credential\",\"speaking_for\",\"project\",\"slice_name\",\"slice_urn\",\"am_url\"," +
                "array_to_string(\"shared_with\", ' ') AS shared_with_ssv,\"owner\",\"status\",\"status_details\" " +
                " FROM experiment ")
    List<Experiment> findAll();

//    @SqlQuery("INSERT INTO experiment (id,name,request_rspec,speaks_for_credential, owner) \n" +
    @SqlQuery("INSERT INTO experiment (id,request_rspec,speaks_for_credential, owner) \n" +
//                "VALUES (DEFAULT, 'removeme', :requestRspec, :speaksForCredential, :ownerAsString) " +
                "VALUES (DEFAULT, :requestRspec, :speaksForCredential, :ownerAsString) " +
                "RETURNING id")
    Long insert(@BindBean Experiment experiment);


    @SqlUpdate("UPDATE experiment set expire=:expire,created=:created,manifest_rspec=:manifestRspec," +
            "            speaking_for=:speakingForAsString,project=:project,slice_name=:sliceName,slice_urn=:sliceUrnAsString," +
            "            am_url=:amAsString,owner=:ownerAsString,status=:statusAsString " +
            " WHERE id=:id")
    void update(@BindBean Experiment res);
}
